
local wx = require "wx"
local rcr = require "barf.rcr"
local _G = _G
local ipairs,pairs,error
    = ipairs,pairs,error
local strbyte, strsub, strmatch, strrep, strchar
    = string.byte, string.sub, string.match, string.rep, string.char
local tconcat = table.concat
local bit = require "bit"
local nes = require "barf.nes"


module "barf.editors"


function chrimage(info, parentWindow)
    local rom = _G.rom;
    
    local tilesheet = wx.wxPanel(
        parentWindow,
        wx.wxID_ANY,
        wx.wxPoint(0,0),
        wx.wxSize(256,256)
    );
    tilesheet.BackgroundColour = wx.wxColour(0,0,0);
    
    local bitmap = wx.wxBitmap(256,256,-1);
    local bitmapDC = wx.wxMemoryDC();
    bitmapDC:SelectObject(bitmap);
    
    local greyscale = {
        wx.wxPen(wx.wxColour(56,56,56), 1, wx.wxSOLID),
        wx.wxPen(wx.wxColour(112,112,112), 1, wx.wxSOLID),
        wx.wxPen(wx.wxColour(168,168,168), 1, wx.wxSOLID),
        wx.wxPen(wx.wxColour(224,224,224), 1, wx.wxSOLID)
    };
    bitmapDC.Pen = wx.wxPen(wx.wxRED_PEN);
    local random = _G.math.random;
    local DrawPoint = bitmapDC.DrawPoint
    local SetPen = bitmapDC.SetPen
    for x=0,255 do
        for y=0,255 do
            SetPen(bitmapDC, nes.pens[random(1,#(nes.pens))]);
            DrawPoint(bitmapDC,x,y);
        end
    end
    
    tilesheet:Connect(wx.wxEVT_ERASE_BACKGROUND, function() end);
    
    tilesheet:Connect(wx.wxEVT_PAINT,
        function()
            local dc = wx.wxPaintDC(tilesheet);
            dc:Blit(0, 0, 256, 256, bitmapDC, 0, 0);
            dc:delete();
        end);
end

return chrimage;
